/*!
* Backbone.CollectionView, v0.9.0
* Copyright (c)2013 Rotunda Software, LLC.
* Distributed under MIT license
* http://github.com/rotundasoftware/backbone-collection-view
*/

(function(){function e(e){var t=[];if(!_.isArray(e))throw Error("Option declarations must be an array.");return _.each(e,function(e){var i,s,n;if(s=!1,n=void 0,_.isString(e))i=e;else{if(!_.isObject(e))throw Error("Each element in the option declarations array must be either a string or an object.");i=_.first(_.keys(e)),n=_.clone(e[i])}"!"===i[i.length-1]&&(s=!0,i=i.slice(0,i.length-1)),t.push({name:i,required:s,defaultValue:n})}),t}var t=Backbone.View,i="model",s=["collection","modelView","modelViewOptions","itemTemplate","selectableModelsFilter","sortableModelsFilter","visibleModelsFilter","itemTemplateFunction","detachedRendering","sortableOptions"],n={background:"transparent",border:"none","box-shadow":"none"};Backbone.CollectionView=Backbone.View.extend({tagName:"ul",events:{"mousedown li, td":"_listItem_onMousedown","dblclick li, td":"_listItem_onDoubleClick",click:"_listBackground_onClick","click ul.collection-list, table.collection-list":"_listBackground_onClick",keydown:"_onKeydown"},spawnMessages:{focus:"focus"},passMessages:{"*":"."},initializationOptions:[{collection:new Backbone.Collection},{modelView:null},{modelViewOptions:{}},{itemTemplate:null},{itemTemplateFunction:null},{selectable:!0},{clickToSelect:!0},{selectableModelsFilter:null},{visibleModelsFilter:null},{sortableModelsFilter:null},{selectMultiple:!1},{clickToToggle:!1},{processKeyEvents:!0},{sortable:!1},{sortableOptions:null},{detachedRendering:!1},{emptyListCaption:null}],initialize:function(e){Backbone.ViewOptions.add(this,"initializationOptions"),this.setOptions(e),this._hasBeenRendered=!1,this._isBackboneCourierAvailable()&&Backbone.Courier.add(this),this.$el.data("view",this),this.$el.addClass("collection-list"),this.selectable&&this.$el.addClass("selectable"),this.processKeyEvents&&this.$el.attr("tabindex",0),this.selectedItems=[],this._updateItemTemplate(),this.collection&&this._registerCollectionEvents(),this.viewManager=new ChildViewContainer},onOptionsChanged:function(e,t){var i=!1,n=this;_.each(_.keys(e),function(o){var l=e[o],a=t[o];switch(o){case"collection":l!==a&&(n.stopListening(a),n._registerCollectionEvents());break;case"selectMultiple":!l&&n.selectedItems.length>1&&n.setSelectedModel(_.first(n.selectedItems),{by:"cid"});break;case"selectable":!l&&n.selectedItems.length>0&&n.setSelectedModels([]);break;case"selectableModelsFilter":l&&_.isFunction(l)&&n._validateSelection();break;case"itemTemplate":n._updateItemTemplate();break;case"processKeyEvents":l&&n.$el.attr("tabindex",0);break;case"modelView":n.viewManager.each(function(e){n.viewManager.remove(e),e.remove()})}_.contains(s,o)&&(i=!0)}),this._hasBeenRendered&&i&&this.render()},setOption:function(e,t){var i={};i[e]=t,this.setOptions(i)},getSelectedModel:function(e){return _.first(this.getSelectedModels(e))},getSelectedModels:function(e){var t=this;e=_.extend({},{by:i},e);var s=e.by,n=[];switch(s){case"id":_.each(this.selectedItems,function(e){n.push(t.collection.get(e).id)});break;case"cid":n=n.concat(this.selectedItems);break;case"offset":var o=0,l=this._getVisibleItemEls();l.each(function(){var e=$(this);e.is(".selected")&&n.push(o),o++});break;case"model":_.each(this.selectedItems,function(e){n.push(t.collection.get(e))});break;case"view":_.each(this.selectedItems,function(e){n.push(t.viewManager.findByModel(t.collection.get(e)))})}return n},setSelectedModels:function(e,t){if(!_.isArray(e))throw"Invalid parameter value";if(this.selectable||!(e.length>0)){t=_.extend({},{silent:!1,by:i},t);var s=t.by,n=[];switch(s){case"cid":n=e;break;case"id":this.collection.each(function(t){_.contains(e,t.id)&&n.push(t.cid)});break;case"model":n=_.pluck(e,"cid");break;case"view":_.each(e,function(e){n.push(e.model.cid)});break;case"offset":var o=0,l=this._getVisibleItemEls();l.each(function(){var t=$(this);_.contains(e,o)&&n.push(t.attr("data-model-cid")),o++})}var a=this.getSelectedModels(),d=_.clone(this.selectedItems);this.selectedItems=this._convertStringsToInts(n),this._validateSelection();var r=this.getSelectedModels();this._containSameElements(d,this.selectedItems)||(this._addSelectedClassToSelectedItems(d),t.silent||(this.trigger("selectionChanged",r,a),this._isBackboneCourierAvailable()&&this.spawn("selectionChanged",{selectedModels:r,oldSelectedModels:a})),this.updateDependentControls())}},setSelectedModel:function(e,t){e||0===e?this.setSelectedModels([e],t):this.setSelectedModels([],t)},render:function(){var e=this;this._hasBeenRendered=!0,this.selectable&&this._saveSelection();var t;t=this._getContainerEl();var i=this.viewManager;this.viewManager=new ChildViewContainer,i.each(function(t){e.collection.get(t.model.cid)?t.$el.detach():t.remove()}),t.empty();var s;if(this.detachedRendering&&(s=document.createDocumentFragment()),this.collection.each(function(e){var n=i.findByModelCid(e.cid);_.isUndefined(n)&&(n=this._createNewModelView(e,this._getModelViewOptions(e))),this._insertAndRenderModelView(n,s||t)},this),this.detachedRendering&&t.append(s),this.sortable){var n=_.extend({axis:"y",distance:10,forcePlaceholderSize:!0,start:_.bind(this._sortStart,this),change:_.bind(this._sortChange,this),stop:_.bind(this._sortStop,this),receive:_.bind(this._receive,this),over:_.bind(this._over,this)},_.result(this,"sortableOptions"));e._isRenderedAsTable()?n.items="> tbody > tr:not(.not-sortable)":e._isRenderedAsList()&&(n.items="> li:not(.not-sortable)"),this.$el=this.$el.sortable(n)}this._showEmptyListCaptionIfAppropriate(),this.trigger("render"),this._isBackboneCourierAvailable()&&this.spawn("render"),this.selectable&&(this._restoreSelection(),this.updateDependentControls()),_.isFunction(this.onAfterRender)&&this.onAfterRender()},_showEmptyListCaptionIfAppropriate:function(){if(this.emptyListCaption){var e=this._getVisibleItemEls();if(0===e.length){var t;t=_.isFunction(this.emptyListCaption)?this.emptyListCaption():this.emptyListCaption;var i=$("<var class='empty-list-caption'>"+t+"</var>");$emptyListCaptionEl=this._isRenderedAsList()?i.wrapAll("<li class='not-sortable'></li>").parent().css(n):i.wrapAll("<tr class='not-sortable'><td></td></tr>").parent().parent().css(n),this._getContainerEl().append($emptyListCaptionEl)}}},_removeEmptyListCaption:function(){this._isRenderedAsList()?this._getContainerEl().find("> li > var.empty-list-caption").parent().remove():this._getContainerEl().find("> tr > td > var.empty-list-caption").parent().parent().remove()},_insertAndRenderModelView:function(e,t,i){var s=this._wrapModelView(e);11===t.nodeType?t.appendChild(s.get(0)):!_.isUndefined(i)&&i>0&&this.collection.length-1>i?t.children().eq(i).before(s):t.append(s);var n=e.render();n===!1&&(s.hide(),s.addClass("not-visible"));var o=!1;_.isFunction(this.visibleModelsFilter)&&(o=!this.visibleModelsFilter(e.model),o&&(1===s.children().length?s.hide():e.$el.hide(),s.addClass("not-visible"))),!o&&this.emptyListCaption&&this._removeEmptyListCaption(),this.viewManager.add(e)},updateDependentControls:function(){this.trigger("updateDependentControls",this.getSelectedModels()),this._isBackboneCourierAvailable()&&this.spawn("updateDependentControls",{selectedModels:this.getSelectedModels()})},remove:function(){this.viewManager.each(function(e){e.remove()}),Backbone.View.prototype.remove.apply(this,arguments)},_removeModelView:function(e){var t=this.viewManager,i=t.findByModelCid(e.cid);this.selectable&&this._saveSelection(),t.remove(i),i.remove(),this._getContainerEl().children("[data-model-cid="+e.cid+"]").remove(),this.selectable&&this._restoreSelection(),this._showEmptyListCaptionIfAppropriate()},_validateSelectionAndRender:function(){this._validateSelection(),this.render()},_registerCollectionEvents:function(){this.listenTo(this.collection,"add",function(e){if(this._hasBeenRendered){var t=this._createNewModelView(e,this._getModelViewOptions(e));this._insertAndRenderModelView(t,this._getContainerEl(),this.collection.indexOf(e))}this._isBackboneCourierAvailable()&&this.spawn("add")}),this.listenTo(this.collection,"remove",function(e){this._hasBeenRendered&&this._removeModelView(e),this._isBackboneCourierAvailable()&&this.spawn("remove")}),this.listenTo(this.collection,"reset",function(){this._hasBeenRendered&&this.render(),this._isBackboneCourierAvailable()&&this.spawn("reset")}),this.listenTo(this.collection,"sort",function(e,t){this._hasBeenRendered&&t.add!==!0&&this.render(),this._isBackboneCourierAvailable()&&this.spawn("sort")})},_getContainerEl:function(){if(this._isRenderedAsTable()){var e=this.$el.find("> tbody");if(e.length>0)return e}return this.$el},_getClickedItemId:function(e){var t=null,i=$(e.currentTarget);if(i.closest(".collection-list").get(0)===this.$el.get(0)){var s=i.closest("[data-model-cid]");return s.length>0&&(t=s.attr("data-model-cid"),$.isNumeric(t)&&(t=parseInt(t,10))),t}},_updateItemTemplate:function(){var e;if(this.itemTemplate){if(0===$(this.itemTemplate).length)throw"Could not find item template from selector: "+this.itemTemplate;e=$(this.itemTemplate).html()}else e=this.$(".item-template").html();e&&(this.itemTemplateFunction=_.template(e))},_validateSelection:function(){var e=_.pluck(this.collection.models,"cid");this.selectedItems=_.intersection(e,this.selectedItems),_.isFunction(this.selectableModelsFilter)&&(this.selectedItems=_.filter(this.selectedItems,function(e){return this.selectableModelsFilter.call(this,this.collection.get(e))},this))},_saveSelection:function(){if(!this.selectable)throw"Attempt to save selection on non-selectable list";this.savedSelection={items:_.clone(this.selectedItems),offset:this.getSelectedModel({by:"offset"})}},_restoreSelection:function(){if(!this.savedSelection)throw"Attempt to restore selection but no selection has been saved!";this.setSelectedModels([],{silent:!0}),this.savedSelection.items.length>0&&(this.setSelectedModels(this.savedSelection.items,{by:"cid",silent:!0}),0===this.selectedItems.length&&this.setSelectedModel(this.savedSelection.offset,{by:"offset"}),this.selectedItems.length!==this.savedSelection.items.length&&(this.trigger("selectionChanged",this.getSelectedModels(),[]),this._isBackboneCourierAvailable()&&this.spawn("selectionChanged",{selectedModels:this.getSelectedModels(),oldSelectedModels:[]}))),delete this.savedSelection},_addSelectedClassToSelectedItems:function(e){_.isUndefined(e)&&(e=[]);var t=e;t=_.without(t,this.selectedItems),_.each(t,function(e){this._getContainerEl().find("[data-model-cid="+e+"]").removeClass("selected")},this);var i=this.selectedItems;i=_.without(i,e),_.each(i,function(e){this._getContainerEl().find("[data-model-cid="+e+"]").addClass("selected")},this)},_reorderCollectionBasedOnHTML:function(){var e=this;this._getContainerEl().children().each(function(){var t=$(this).attr("data-model-cid");if(t){var i=e.collection.get(t);i&&(e.collection.remove(i,{silent:!0}),e.collection.add(i,{silent:!0,sort:!e.collection.comparator}))}}),this.collection.trigger("reorder"),this._isBackboneCourierAvailable()&&this.spawn("reorder"),this.collection.comparator&&this.collection.sort()},_getModelViewConstructor:function(){return this.modelView||t},_getModelViewOptions:function(e){return _.extend({model:e},this.modelViewOptions)},_createNewModelView:function(e,t){var i=this._getModelViewConstructor(e);if(_.isUndefined(i))throw"Could not find modelView constructor for model";var s=new i(t);return s.collectionListView=this,s},_wrapModelView:function(e){var t,i=this;return this._isRenderedAsTable()?t=e.$el.attr("data-model-cid",e.model.cid):this._isRenderedAsList()&&(t="li"===e.$el.prop("tagName").toLowerCase()?e.$el.attr("data-model-cid",e.model.cid):e.$el.wrapAll("<li data-model-cid='"+e.model.cid+"'></li>").parent()),_.isFunction(this.sortableModelsFilter)&&(this.sortableModelsFilter.call(i,e.model)||t.addClass("not-sortable")),_.isFunction(this.selectableModelsFilter)&&(this.selectableModelsFilter.call(i,e.model)||t.addClass("not-selectable")),t},_convertStringsToInts:function(e){return _.map(e,function(e){if(!_.isString(e))return e;var t=parseInt(e,10);return t==e?t:e})},_containSameElements:function(e,t){if(e.length!=t.length)return!1;var i=_.intersection(e,t).length;return i==e.length},_isRenderedAsTable:function(){return"table"===this.$el.prop("tagName").toLowerCase()},_isRenderedAsList:function(){return!this._isRenderedAsTable()},_getVisibleItemEls:function(){var e=[];return e=this._getContainerEl().find("> [data-model-cid]:not(.not-visible)")},_charCodes:{upArrow:38,downArrow:40},_isBackboneCourierAvailable:function(){return!_.isUndefined(Backbone.Courier)},_sortStart:function(e,t){var i=this.collection.get(t.item.attr("data-model-cid"));this.trigger("sortStart",i),this._isBackboneCourierAvailable()&&this.spawn("sortStart",{modelBeingSorted:i})},_sortChange:function(e,t){var i=this.collection.get(t.item.attr("data-model-cid"));this.trigger("sortChange",i),this._isBackboneCourierAvailable()&&this.spawn("sortChange",{modelBeingSorted:i})},_sortStop:function(e,t){var i=this.collection.get(t.item.attr("data-model-cid")),s=this._getContainerEl(),n=s.children().index(t.item);-1==n&&this.collection.remove(i),this._reorderCollectionBasedOnHTML(),this.updateDependentControls(),this.trigger("sortStop",i,n),this._isBackboneCourierAvailable()&&this.spawn("sortStop",{modelBeingSorted:i,newIndex:n})},_receive:function(e,t){var i=t.sender,s=i.data("view");if(s&&s.collection){var n=this._getContainerEl().children().index(t.item),o=s.collection.get(t.item.attr("data-model-cid"));s.collection.remove(o),this.collection.add(o,{at:n}),o.collection=this.collection,this.setSelectedModel(o)}},_over:function(){this._getContainerEl().find("> var.empty-list-caption").hide()},_onKeydown:function(e){if(!this.processKeyEvents)return!0;var t=!1;if(1==this.getSelectedModels({by:"offset"}).length){var i=this.getSelectedModel({by:"offset"});e.which===this._charCodes.upArrow&&0!==i?(this.setSelectedModel(i-1,{by:"offset"}),t=!0):e.which===this._charCodes.downArrow&&i!==this.collection.length-1&&(this.setSelectedModel(i+1,{by:"offset"}),t=!0)}return!t},_listItem_onMousedown:function(e){if(this.selectable&&this.clickToSelect){var t=this._getClickedItemId(e);if(t){if(_.isFunction(this.selectableModelsFilter)&&!this.selectableModelsFilter.call(this,this.collection.get(t)))return;if(this.selectMultiple&&e.shiftKey){var i=-1;this.selectedItems.length>0&&this.collection.find(function(e){return i++,_.contains(this.selectedItems,e.cid)},this);var s=-1;this.collection.find(function(e){return s++,e.cid==t},this);for(var n=-1==i?s:i,o=Math.min(s,n),l=Math.max(s,n),a=[],d=o;l>=d;d++)a.push(this.collection.at(d).cid);if(this.setSelectedModels(a,{by:"cid"}),document.selection&&document.selection.empty)document.selection.empty();else if(window.getSelection){var r=window.getSelection();r&&r.removeAllRanges&&r.removeAllRanges()}}else this.selectMultiple&&(this.clickToToggle||e.metaKey)?_.contains(this.selectedItems,t)?this.setSelectedModels(_.without(this.selectedItems,t),{by:"cid"}):this.setSelectedModels(_.union(this.selectedItems,t),{by:"cid"}):this.setSelectedModels([t],{by:"cid"})}else this.setSelectedModels([])}},_listItem_onDoubleClick:function(e){var t=this._getClickedItemId(e);if(t){var i=this.collection.get(t);this.trigger("doubleClick",i),this._isBackboneCourierAvailable()&&this.spawn("doubleClick",{clickedModel:i})}},_listBackground_onClick:function(e){this.selectable&&$(e.target).is(".collection-list")&&this.setSelectedModels([])}},{setDefaultModelViewConstructor:function(e){t=e}}),Backbone.ViewOptions={},Backbone.ViewOptions.add=function(t,i){_.isUndefined(i)&&(i="options"),t.setOptions=function(t){var s=this,n={},o={},l=_.result(this,i);if(!_.isUndefined(l)){var a=e(l);_.each(a,function(e){if(thisOptionName=e.name,thisOptionRequired=e.required,thisOptionDefaultValue=e.defaultValue,thisOptionRequired&&(!t||!_.contains(_.keys(t),thisOptionName)&&_.isUndefined(s[thisOptionName])||_.isUndefined(t[thisOptionName])))throw Error('Required option "'+thisOptionName+'" was not supplied.');t&&thisOptionName in t?(_.isUndefined(s[thisOptionName])||(o[thisOptionName]=s[thisOptionName],n[thisOptionName]=t[thisOptionName]),s[thisOptionName]=t[thisOptionName]):!_.isUndefined(thisOptionDefaultValue)&&_.isUndefined(s[thisOptionName])&&(s[thisOptionName]=thisOptionDefaultValue)})}_.keys(n).length>0&&(_.isFunction(s.onOptionsChanged)?s.onOptionsChanged(n,o):_.isFunction(s._onOptionsChanged)&&s._onOptionsChanged(n,o))},t.getOptions=function(){var t=_.result(this,i);if(_.isUndefined(t))return[];var s=e(t),n=_.pluck(s,"name");return _.pick(this,n)}},ChildViewContainer=function(e,t){var i=function(e){this._views={},this._indexByModel={},this._indexByCustom={},this._updateLength(),t.each(e,this.add,this)};t.extend(i.prototype,{add:function(e,t){var i=e.cid;this._views[i]=e,e.model&&(this._indexByModel[e.model.cid]=i),t&&(this._indexByCustom[t]=i),this._updateLength()},findByModel:function(e){return this.findByModelCid(e.cid)},findByModelCid:function(e){var t=this._indexByModel[e];return this.findByCid(t)},findByCustom:function(e){var t=this._indexByCustom[e];return this.findByCid(t)},findByIndex:function(e){return t.values(this._views)[e]},findByCid:function(e){return this._views[e]},findIndexByCid:function(e){var i=-1,s=t.find(this._views,function(t){return i++,t.model.cid==e?t:void 0});return s?i:-1},remove:function(e){var i=e.cid;e.model&&delete this._indexByModel[e.model.cid],t.any(this._indexByCustom,function(e,t){return e===i?(delete this._indexByCustom[t],!0):void 0},this),delete this._views[i],this._updateLength()},call:function(e){this.apply(e,t.tail(arguments))},apply:function(e,i){t.each(this._views,function(s){t.isFunction(s[e])&&s[e].apply(s,i||[])})},_updateLength:function(){this.length=t.size(this._views)}});var s=["forEach","each","map","find","detect","filter","select","reject","every","all","some","any","include","contains","invoke","toArray","first","initial","rest","last","without","isEmpty","pluck"];return t.each(s,function(e){i.prototype[e]=function(){var i=t.values(this._views),s=[i].concat(t.toArray(arguments));return t[e].apply(t,s)}}),i}(Backbone,_)})();